/**
 * POCDMT000040Subject.java
 *
 * File generated from the cda::POCDMT000040Subject uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaxehealth;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import net.ihe.gazelle.ips.datatypes.CE;
import net.ihe.gazelle.ips.datatypes.CS;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class POCDMT000040Subject.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Subject", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"awarenessCode",
	"relatedSubject",
	"contextControlCode",
	"nullFlavor",
	"typeCode"
})
@XmlRootElement(name = "POCD_MT000040.Subject")
public class POCDMT000040Subject implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<CS > realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.ips.datatypes.II> templateId;
	@XmlElement(name = "awarenessCode", namespace = "urn:hl7-org:v3")
	public CE awarenessCode;
	@XmlElement(name = "relatedSubject", required = true, namespace = "urn:hl7-org:v3")
	public POCDMT000040RelatedSubject relatedSubject;
	@XmlAttribute(name = "contextControlCode")
	public net.ihe.gazelle.voc.NullFlavor contextControlCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlAttribute(name = "typeCode")
	public net.ihe.gazelle.voc.ParticipationTargetSubject typeCode;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<CS > getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<CS >();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<CS > realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.ips.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.ips.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.ips.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.ips.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.ips.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return awarenessCode.
	 * @return awarenessCode
	 */
	public CE getAwarenessCode() {
	    return awarenessCode;
	}
	
	/**
	 * Set a value to attribute awarenessCode.
	 * @param awarenessCode.
	 */
	public void setAwarenessCode(CE awarenessCode) {
	    this.awarenessCode = awarenessCode;
	}
	
	
	
	
	/**
	 * Return relatedSubject.
	 * @return relatedSubject
	 */
	public POCDMT000040RelatedSubject getRelatedSubject() {
	    return relatedSubject;
	}
	
	/**
	 * Set a value to attribute relatedSubject.
	 * @param relatedSubject.
	 */
	public void setRelatedSubject(POCDMT000040RelatedSubject relatedSubject) {
	    this.relatedSubject = relatedSubject;
	}
	
	
	
	
	/**
	 * Return contextControlCode.
	 * @return contextControlCode
	 */
	public net.ihe.gazelle.voc.NullFlavor getContextControlCode() {
	    return contextControlCode;
	}
	
	/**
	 * Set a value to attribute contextControlCode.
	 * @param contextControlCode.
	 */
	public void setContextControlCode(net.ihe.gazelle.voc.NullFlavor contextControlCode) {
	    this.contextControlCode = contextControlCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return typeCode.
	 * @return typeCode
	 */
	public net.ihe.gazelle.voc.ParticipationTargetSubject getTypeCode() {
	    return typeCode;
	}
	
	/**
	 * Set a value to attribute typeCode.
	 * @param typeCode.
	 */
	public void setTypeCode(net.ihe.gazelle.voc.ParticipationTargetSubject typeCode) {
	    this.typeCode = typeCode;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaxehealth");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Subject").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Subject pOCDMT000040Subject, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Subject != null){
   			cvm.validate(pOCDMT000040Subject, _location, diagnostic);
			{
				int i = 0;
				for (CS realmCode: pOCDMT000040Subject.getRealmCode()){
					CS .validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Subject.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.ips.datatypes.II templateId: pOCDMT000040Subject.getTemplateId()){
					net.ihe.gazelle.ips.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			CE .validateByModule(pOCDMT000040Subject.getAwarenessCode(), _location + "/awarenessCode", cvm, diagnostic);
			POCDMT000040RelatedSubject.validateByModule(pOCDMT000040Subject.getRelatedSubject(), _location + "/relatedSubject", cvm, diagnostic);
    	}
    }

}